import App

#global variable for emitting the plasma streamer
g_sneakerPlasmaCheck = 2
g_sneakerPlasmaConstant = 0

###includes phalanthium wave and spatial charges

def SneakerTorpedoShieldHit(TGObject, pEvent):
	import LoadTacticalSounds
	import SpatialChargesEffects
	import PlasmaRuptureEffects
	import Effects
	import Bridge.BridgeUtils
	import MissionLib

	# Set up
	pObject = App.ObjectClass_Cast(TGObject)

	if not pObject:
#		debug("Unexpected NULL Ptr in TorpedoShieldHit")
		TGObject.CallNextHandler(pEvent)
		return

	# we need a set to put it in
	# this should never be null, but you never know
	pSet = pObject.GetContainingSet()
	if not pSet:
#		debug("Unexpected NULL Set Ptr in TorpedoShieldHit")
		TGObject.CallNextHandler(pEvent)
		return

	pSequence = App.TGSequence_Create()

	################lennie update
	# get some preliminary information so we can determine torp type
	pShip = App.ShipClass_Cast(pEvent.GetFiringObject())
	pShip = App.ShipClass_Cast(pShip)

	# phalantium explosion

	# using damage yield instead of an actual name or token is a hack;
	# I have not found a direct link to type of THIS torpedo 
	# through pEvent and have no idea of the subclass of TGObject,
	# but it doesn't seem to be a Torpedo
	if pEvent.GetDamage() == 100199.0:
		# create the explosion on the target ship
		pExplosion = Effects.CreateWaveExplosion(pEvent.GetRadius() * 180.0, 1.50, pEvent)
		# damage or destroy the firing ship's systems

		if pShip:
			# hull
			iHDamageMax = pShip.GetHull().GetCondition()
			iHDamage = App.g_kSystemWrapper.GetRandomNumber(iHDamageMax * 0.4)
			# minimal 50% hull damage, ~70% mean, 90% maximal damage to remaining integrity
			pShip.DamageSystem(pShip.GetHull(), (iHDamageMax * 0.5) + iHDamage)
		
			# shields
			pShields = pShip.GetShields()
			if pShields:
				iShDamageMax = pShip.GetShields().GetCondition()
				if iShDamageMax > 1:
					# ~20% chance that this launch will completely destroy the shield system
					iShDamage = App.g_kSystemWrapper.GetRandomNumber(iShDamageMax * 0.25)
					# minimal 80% shield damage, ~90% mean damage to remaining integrity
					pShip.DamageSystem(pShields, (iShDamageMax * 0.8) + iShDamage)

			# sensors
			pSensors = pShip.GetSensorSubsystem()
			if pSensors:
				iSeDamageMax = pSensors.GetCondition()
				if iSeDamageMax > 1:
					# ~10% chance that this launch will completely destroy the shield system
					iSeDamage = App.g_kSystemWrapper.GetRandomNumber(iSeDamageMax * 0.45)
					# minimal 60% sensor damage, ~80% mean damage to remaining integrity
	 				pShip.DamageSystem(pSensors, (iSeDamageMax * 0.6) + iSeDamage)
	
			# many ways of querying subsystems; this is just one of them

			#torpedo tubes
			pTorpSys = pShip.GetTorpedoSystem()

			if pTorpSys:
				# iterate through torpedo launchers
				iNumTubes = pTorpSys.GetNumChildSubsystems()
				for jTube in range(iNumTubes):
					pTorpChild = pTorpSys.GetChildSubsystem(jTube)
					if pTorpChild:
						fToDamageMax = pTorpChild.GetConditionPercentage()
						if fToDamageMax > 0.0:
							# ~30% chance that this launch will completely destroy the launcher system
							fToDamage = App.g_kSystemWrapper.GetRandomNumber(fToDamageMax * 60.0)
	
							# not sure if method clamps, so just to be safe
							if (fToDamage > 40.0):
								fToDamage = 40.0						

							# minimal 60% torpedo tube damage, ~90% mean damage to remaining integrity
							pTorpChild.SetConditionPercentage((fToDamageMax * 0.4) - (fToDamage * 0.01))

			# impulse drive
			pImpSys = pShip.GetImpulseEngineSubsystem()
	
			if pImpSys:
				# iterate through impulse drive units
				iNumImp = pImpSys.GetNumChildSubsystems()
				for iEng in range(iNumImp):
					pImpChild = pImpSys.GetChildSubsystem(iEng)
					if pImpChild:
						fImDamageMax = pImpChild.GetConditionPercentage()
						if fImDamageMax > 0.0:
							# ~17% chance that this launch will completely destroy the engine
							fImDamage = App.g_kSystemWrapper.GetRandomNumber(fImDamageMax * 70.0)

							# not sure if method clamps, so just to be safe
							if (fImDamage > 50.0):
								fImDamage = 50.0

							# minimal 50% impulse powerplant damage, ~80% mean damage to remaining integrity
							pImpChild.SetConditionPercentage ((fImDamageMax * 0.5) - (fImDamage * 0.01))

			# Spin our new hulk
			fRot = App.g_kSystemWrapper.GetRandomNumber(70)
			SetLBRandRotation(pShip, (fRot + 1.0))	
	elif pEvent.GetDamage() == 598.0:
		##### sneaker98 change
		pExplosion = SpatialChargesEffects.CreateSpatialExplosion(3, pEvent, pSet.GetEffectRoot())
		#pExplosion = CreatePlasma(1.5, pEvent, pSet.GetEffectRoot())

		# non-phalantium or spatial charge explosion
	else:
		pExplosion = Effects.CreateWeaponExplosion(pEvent.GetRadius() * 3.0, 1.25, pEvent)
		#### end sneaker98 change
	#################end lennie update
	
	pSequence.AddAction(pExplosion)

	if pEvent.GetDamage() == 100199.0:
		pSound = App.TGSoundAction_Create("Phalantium Explosion")
		pSound.SetNode(pObject.GetNode())
		pSequence.AddAction(pSound)	
	
	####sneaker98 change
	elif pEvent.GetDamage() == 598.0:
			pSound = App.TGSoundAction_Create("SpatialExplosion")
			pSound.SetNode(pObject.GetNode())
			pSequence.AddAction(pSound)
	else:
		sSound = LoadTacticalSounds.GetRandomSound( LoadTacticalSounds.g_lsWeaponExplosions )
		pSound = App.TGSoundAction_Create(sSound, 0, pSet.GetName())
		pSound.SetNode(pObject.GetNode())
		pSequence.AddAction(pSound)
	####end sneaker98 change

	################################## sneaker98 call plasma
	pTargetShip = App.ShipClass_Cast(pEvent.GetTargetObject())
	pTargetShip = App.ShipClass_Cast(pTargetShip)
	pWarpSys = pTargetShip.GetWarpEngineSubsystem()
	if pWarpSys:
		# determine how many warp subsystems
		iNumWarp = pWarpSys.GetNumChildSubsystems()
		# go through every one of em.. make em smoke if they are damaged enough
		for iEng in range(iNumWarp):
			pWarpChild = pWarpSys.GetChildSubsystem(iEng)
			if pWarpChild:
				pWarpChildPos = pWarpChild.GetPosition()
				pWarpChildCondition = pWarpChild.GetCondition()
				pWarpChildMaxCondition = pWarpChild.GetMaxCondition()
				if (pWarpChildCondition <= pWarpChildMaxCondition / 2):
					global g_sneakerPlasmaCheck
					sneakerPlasmaRandom = App.g_kSystemWrapper.GetRandomNumber(4)
					if (g_sneakerPlasmaCheck == sneakerPlasmaRandom):
						sneakSize = pObject.GetRadius()
						if sneakSize >= 0.5:
							sneakSize = sneakSize / 4
							if sneakSize < 0.4:
								sneakSize = 0.4
							elif sneakSize > 0.8:
								sneakSize = 0.8
							global g_sneakerPlasmaConstant
							if g_sneakerPlasmaConstant == 0:
								pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pTargetShip.GetNode())
								kEmitDir = pEvent.GetObjectHitNormal()
								pAttachTo = pTargetShip.GetNode()
								pPlasmaExplosion1 = Effects.CreateExplosionPuffHigh(1.25, 1.0, pEmitFrom, pWarpChildPos, kEmitDir, pAttachTo)
								pSequence.AddAction(pPlasmaExplosion1)
								pPlasmaExplosion2 = Effects.CreateExplosionPuffHigh(0.75, 0.8, pEmitFrom, pWarpChildPos, kEmitDir, pAttachTo)
								pSequence.AddAction(pPlasmaExplosion2)
								pPlasmaExplosion3 = Effects.CreateExplosionPuffHigh(1.50, 1.2, pEmitFrom, pWarpChildPos, kEmitDir, pAttachTo)
								pSequence.AddAction(pPlasmaExplosion3)
								fSneakerName = "data/Textures/Effects/PlasmaBlue.tga"
								sneakerShipProperty = pTargetShip.GetShipProperty()
								if sneakerShipProperty:
									sneakerSpecies = sneakerShipProperty.GetSpecies()
									sneakerName = sneakerShipProperty.GetShipName()
									if (sneakerName == "bugship"):
										fSneakerName = "data/Textures/Effects/PlasmaPurple.tga"
									elif (sneakerName == "dombb"):
										fSneakerName = "data/Textures/Effects/PlasmaPurple.tga"
									elif ((sneakerSpecies >= 100) and (sneakerSpecies <= 199)):
										fSneakerName = "data/Textures/Effects/PlasmaBlue.tga"
									elif ((sneakerSpecies >= 200) and (sneakerSpecies <= 299)):
										fSneakerName = "data/Textures/Effects/PlasmaYellow.tga"
									elif ((sneakerSpecies >= 300) and (sneakerSpecies <= 399)):
										fSneakerName = "data/Textures/Effects/PlasmaGreen.tga"
									elif ((sneakerSpecies >= 400) and (sneakerSpecies <= 499)):
										fSneakerName = "data/Textures/Effects/PlasmaRed.tga"
									elif ((sneakerSpecies >= 500) and (sneakerSpecies <= 599)):
										fSneakerName = "data/Textures/Effects/PlasmaPurple.tga"
									elif ((sneakerSpecies >= 600) and (sneakerSpecies <= 699)):
										fSneakerName = "data/Textures/Effects/PlasmaYellow.tga"
									elif ((sneakerSpecies >= 900) and (sneakerSpecies <= 999)):
										fSneakerName = "data/Textures/Effects/PlasmaPurple.tga"
									else:
										fSneakerName = "data/Textures/Effects/PlasmaBlue.tga"
								pPlasma = PlasmaRuptureEffects.CreatePlasma(sneakSize, pEvent, pSet.GetEffectRoot(), pWarpChildPos, fSneakerName)
								pSequence.AddAction(pPlasma)
								g_sneakerPlasmaConstant = 5
							else:
								g_sneakerPlasmaConstant = g_sneakerPlasmaConstant - 1

#					####sneaker98 character sound
#					pSet = App.g_kSetManager.GetSet("bridge")
#					pEngineer = App.CharacterClass_GetObject(pSet, "Engineer")
#					pDatabase = pEngineer.GetDatabase()
#					if pWarpChild.GetName() == 'PortNacelle':
#						App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "PortNacelleRupture", None, 0, pDatabase, App.CSP_SPONTANEOUS).Play()
#					elif pWarpChild.GetName() == 'StarNacelle':
#						App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "StarNacelleRupture", None, 0, pDatabase, App.CSP_SPONTANEOUS).Play()
#					else:
#						App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "GeneralNacelleRupture", None, 0, pDatabase, App.CSP_SPONTANEOUS).Play()
#					pObject.CallNextHandler(pEvent)
#					####end sneaker98 sounds
	################################## sneaker98 end call plasma
	pSequence.Play()


def SneakerTorpedoHullHit(TGObject, pEvent):
	import LoadTacticalSounds
	import SpatialChargesEffects
	import PlasmaRuptureEffects
	import Effects
	import Bridge.BridgeUtils
	import MissionLib

	# Set up
	pObject = App.ObjectClass_Cast(TGObject)

	if not pObject:
#		debug("Unexpected NULL Ptr in TorpedoHullHit")
		TGObject.CallNextHandler(pEvent)
		return

	# we need a set to put it in
	# this should never be null, but you never know
	pSet = pObject.GetContainingSet()
	if not pSet:
#		debug("Unexpected NULL Set Ptr in TorpedoHullHit")
		TGObject.CallNextHandler(pEvent)
		return

	pSequence = App.TGSequence_Create()

	################lennie update
	# get some preliminary information so we can determine torp type
	pShip = App.ShipClass_Cast(pEvent.GetFiringObject())
	pShip = App.ShipClass_Cast(pShip)

	# phalantium explosion

	# using damage yield instead of an actual name or token is a hack;
	# I have not found a direct link to type of THIS torpedo 
	# through pEvent and have no idea of the subclass of TGObject,
	# but it doesn't seem to be a Torpedo
	if pEvent.GetDamage() == 100199.0:
		# create the explosion on the target ship
		pExplosion = Effects.CreateWaveExplosion(pEvent.GetRadius() * 180.0, 1.50, pEvent)
		# damage or destroy the firing ship's systems

		if pShip:
			# hull
			iHDamageMax = pShip.GetHull().GetCondition()
			iHDamage = App.g_kSystemWrapper.GetRandomNumber(iHDamageMax * 0.4)
			# minimal 50% hull damage, ~70% mean, 90% maximal damage to remaining integrity
			pShip.DamageSystem(pShip.GetHull(), (iHDamageMax * 0.5) + iHDamage)
		
			# shields
			pShields = pShip.GetShields()
			if pShields:
				iShDamageMax = pShip.GetShields().GetCondition()
				if iShDamageMax > 1:
					# ~20% chance that this launch will completely destroy the shield system
					iShDamage = App.g_kSystemWrapper.GetRandomNumber(iShDamageMax * 0.25)
					# minimal 80% shield damage, ~90% mean damage to remaining integrity
					pShip.DamageSystem(pShields, (iShDamageMax * 0.8) + iShDamage)

			# sensors
			pSensors = pShip.GetSensorSubsystem()
			if pSensors:
				iSeDamageMax = pSensors.GetCondition()
				if iSeDamageMax > 1:
					# ~10% chance that this launch will completely destroy the shield system
					iSeDamage = App.g_kSystemWrapper.GetRandomNumber(iSeDamageMax * 0.45)
					# minimal 60% sensor damage, ~80% mean damage to remaining integrity
	 				pShip.DamageSystem(pSensors, (iSeDamageMax * 0.6) + iSeDamage)
	
			# many ways of querying subsystems; this is just one of them

			#torpedo tubes
			pTorpSys = pShip.GetTorpedoSystem()

			if pTorpSys:
				# iterate through torpedo launchers
				iNumTubes = pTorpSys.GetNumChildSubsystems()
				for jTube in range(iNumTubes):
					pTorpChild = pTorpSys.GetChildSubsystem(jTube)
					if pTorpChild:
						fToDamageMax = pTorpChild.GetConditionPercentage()
						if fToDamageMax > 0.0:
							# ~30% chance that this launch will completely destroy the launcher system
							fToDamage = App.g_kSystemWrapper.GetRandomNumber(fToDamageMax * 60.0)
	
							# not sure if method clamps, so just to be safe
							if (fToDamage > 40.0):
								fToDamage = 40.0						

							# minimal 60% torpedo tube damage, ~90% mean damage to remaining integrity
							pTorpChild.SetConditionPercentage((fToDamageMax * 0.4) - (fToDamage * 0.01))

			# impulse drive
			pImpSys = pShip.GetImpulseEngineSubsystem()
	
			if pImpSys:
				# iterate through impulse drive units
				iNumImp = pImpSys.GetNumChildSubsystems()
				for iEng in range(iNumImp):
					pImpChild = pImpSys.GetChildSubsystem(iEng)
					if pImpChild:
						fImDamageMax = pImpChild.GetConditionPercentage()
						if fImDamageMax > 0.0:
							# ~17% chance that this launch will completely destroy the engine
							fImDamage = App.g_kSystemWrapper.GetRandomNumber(fImDamageMax * 70.0)

							# not sure if method clamps, so just to be safe
							if (fImDamage > 50.0):
								fImDamage = 50.0

							# minimal 50% impulse powerplant damage, ~80% mean damage to remaining integrity
							pImpChild.SetConditionPercentage ((fImDamageMax * 0.5) - (fImDamage * 0.01))

			# Spin our new hulk
			fRot = App.g_kSystemWrapper.GetRandomNumber(70)
			SetLBRandRotation(pShip, (fRot + 1.0))

	#### sneaker change
	elif pEvent.GetDamage() == 598.0:
		pExplosion = SpatialChargesEffects.CreateSpatialExplosion(3, pEvent, pSet.GetEffectRoot())
		#pExplosion = CreatePlasma(1.5, pEvent, pSet.GetEffectRoot())

		# non-phalantium or spatial charge explosion
	else:
		pExplosion = Effects.CreateWeaponExplosion(pEvent.GetRadius() * 3.0, 1.25, pEvent)
	#### end sneaker98 change

	#################end lennie update


	pSequence.AddAction(pExplosion)

	if (App.EffectController_GetEffectLevel() >= App.EffectController.MEDIUM):
		if (App.g_kSystemWrapper.GetRandomNumber(10) < 5):
			pSparks = Effects.CreateWeaponSparks(1.0, pEvent, pSet.GetEffectRoot())
			pSequence.AddAction(pSparks)

		if (App.g_kSystemWrapper.GetRandomNumber(10) < 2):
			pSmoke = Effects.CreateWeaponSmoke(1.0 + App.g_kSystemWrapper.GetRandomNumber(5) * 0.5, 0.3, pEvent, pSet.GetEffectRoot())	
			pSequence.AddAction(pSmoke, App.TGAction_CreateNull(), 0.5)

	if pEvent.GetDamage() == 100199.0:
		pSound = App.TGSoundAction_Create("Phalantium Explosion")
		pSound.SetNode(pObject.GetNode())
		pSequence.AddAction(pSound)	
	
	#### sneaker98 change
	elif pEvent.GetDamage() == 598.0:
		pSound = App.TGSoundAction_Create("SpatialExplosion")
		pSound.SetNode(pObject.GetNode())
		pSequence.AddAction(pSound)

	else:
		sSound = LoadTacticalSounds.GetRandomSound( LoadTacticalSounds.g_lsWeaponExplosions )
		pSound = App.TGSoundAction_Create(sSound, 0, pSet.GetName())
		pSound.SetNode(pObject.GetNode())
		pSequence.AddAction(pSound)
	####end sneaker98 change

	################################## sneaker98 call plasma
	pTargetShip = App.ShipClass_Cast(pEvent.GetTargetObject())
	pTargetShip = App.ShipClass_Cast(pTargetShip)
	pWarpSys = pTargetShip.GetWarpEngineSubsystem()
	if pWarpSys:
		# determine how many warp subsystems
		iNumWarp = pWarpSys.GetNumChildSubsystems()
		# go through every one of em.. make em smoke if they are damaged enough
		for iEng in range(iNumWarp):
			pWarpChild = pWarpSys.GetChildSubsystem(iEng)
			if pWarpChild:
				pWarpChildPos = pWarpChild.GetPosition()
				pWarpChildCondition = pWarpChild.GetCondition()
				pWarpChildMaxCondition = pWarpChild.GetMaxCondition()
				if (pWarpChildCondition <= pWarpChildMaxCondition / 2):
					global g_sneakerPlasmaCheck
					sneakerPlasmaRandom = App.g_kSystemWrapper.GetRandomNumber(4)
					if (g_sneakerPlasmaCheck == sneakerPlasmaRandom):
						sneakSize = pObject.GetRadius()
						if sneakSize >= 0.5:
							sneakSize = sneakSize / 4
							if sneakSize < 0.4:
								sneakSize = 0.4
							elif sneakSize > 0.8:
								sneakSize = 0.8
							global g_sneakerPlasmaConstant
							if g_sneakerPlasmaConstant == 0:
								pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pTargetShip.GetNode())
								kEmitDir = pEvent.GetObjectHitNormal()
								pAttachTo = pTargetShip.GetNode()
								pPlasmaExplosion1 = Effects.CreateExplosionPuffHigh(1.25, 1.0, pEmitFrom, pWarpChildPos, kEmitDir, pAttachTo)
								pSequence.AddAction(pPlasmaExplosion1)
								pPlasmaExplosion2 = Effects.CreateExplosionPuffHigh(0.75, 0.8, pEmitFrom, pWarpChildPos, kEmitDir, pAttachTo)
								pSequence.AddAction(pPlasmaExplosion2)
								pPlasmaExplosion3 = Effects.CreateExplosionPuffHigh(1.50, 1.2, pEmitFrom, pWarpChildPos, kEmitDir, pAttachTo)
								pSequence.AddAction(pPlasmaExplosion3)
								fSneakerName = "data/Textures/Effects/PlasmaBlue.tga"
								sneakerShipProperty = pTargetShip.GetShipProperty()
								if sneakerShipProperty:
									sneakerSpecies = sneakerShipProperty.GetSpecies()
									sneakerName = sneakerShipProperty.GetShipName()
									if (sneakerName == "bugship"):
										fSneakerName = "data/Textures/Effects/PlasmaPurple.tga"
									elif (sneakerName == "dombb"):
										fSneakerName = "data/Textures/Effects/PlasmaPurple.tga"
									elif ((sneakerSpecies >= 100) and (sneakerSpecies <= 199)):
										fSneakerName = "data/Textures/Effects/PlasmaBlue.tga"
									elif ((sneakerSpecies >= 200) and (sneakerSpecies <= 299)):
										fSneakerName = "data/Textures/Effects/PlasmaYellow.tga"
									elif ((sneakerSpecies >= 300) and (sneakerSpecies <= 399)):
										fSneakerName = "data/Textures/Effects/PlasmaGreen.tga"
									elif ((sneakerSpecies >= 400) and (sneakerSpecies <= 499)):
										fSneakerName = "data/Textures/Effects/PlasmaRed.tga"
									elif ((sneakerSpecies >= 500) and (sneakerSpecies <= 599)):
										fSneakerName = "data/Textures/Effects/PlasmaPurple.tga"
									elif ((sneakerSpecies >= 600) and (sneakerSpecies <= 699)):
										fSneakerName = "data/Textures/Effects/PlasmaYellow.tga"
									elif ((sneakerSpecies >= 900) and (sneakerSpecies <= 999)):
										fSneakerName = "data/Textures/Effects/PlasmaPurple.tga"
									else:
										fSneakerName = "data/Textures/Effects/PlasmaBlue.tga"
								pPlasma = PlasmaRuptureEffects.CreatePlasma(sneakSize, pEvent, pSet.GetEffectRoot(), pWarpChildPos, fSneakerName)
								pSequence.AddAction(pPlasma)
								g_sneakerPlasmaConstant = 5
							else:
								g_sneakerPlasmaConstant = g_sneakerPlasmaConstant - 1

#					####sneaker98 character sound
#					pSet = App.g_kSetManager.GetSet("bridge")
#					pEngineer = App.CharacterClass_GetObject(pSet, "Engineer")
#					pDatabase = pEngineer.GetDatabase()
#					if pWarpChild.GetName() == 'PortNacelle':
#						App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "PortNacelleRupture", None, 0, pDatabase, App.CSP_SPONTANEOUS).Play()
#					elif pWarpChild.GetName() == 'StarNacelle':
#						App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "StarNacelleRupture", None, 0, pDatabase, App.CSP_SPONTANEOUS).Play()
#					else:
#						App.CharacterAction_Create(pEngineer, App.CharacterAction.AT_SAY_LINE, "GeneralNacelleRupture", None, 0, pDatabase, App.CSP_SPONTANEOUS).Play()
#					pObject.CallNextHandler(pEvent)
#					####end sneaker98 sounds
	################################## sneaker98 end call plasma
	pSequence.Play()