import App

#effects for plasma rupture

############################################################# Sneaker98 plasma Changes
def CreatePlasmaHigh(fVelocity, fLife, fSize, pEmitFrom, kEmitPos, kEmitDir, pAttachTo, fSneakerName):

	iTimingId  = App.TGProfilingInfo_StartTiming("Effects::CreatePlasmaHigh")

	pPlasma = App.AnimTSParticleController_Create()

	pPlasma.AddColorKey(0.0, 1.0, 1.0, 1.0)

	pPlasma.AddAlphaKey(0.0, 0.6)
	pPlasma.AddAlphaKey(0.5, 0.5)
	pPlasma.AddAlphaKey(1.0, 0.0)

	pPlasma.AddSizeKey(0.0, 3.4 * fSize)
	pPlasma.AddSizeKey(0.6, 3.4 * fSize)
	pPlasma.AddSizeKey(0.9, 3.4 * fSize)

	pPlasma.SetEmitVelocity(fVelocity)
	pPlasma.SetAngleVariance(2.0)

	# we might want to varry this with the velocity 
	# so the puffs are not so far from each other
	fFrequency = 0.03
	pPlasma.SetEmitLife(8.0)
	pPlasma.SetEmitFrequency(fFrequency)
	pPlasma.SetEffectLifeTime(fLife)

	pPlasma.SetDrawOldToNew(0)

#	pPlasma.CreateTarget("data/Textures/Effects/PlasmaBlue.tga")
	pPlasma.CreateTarget(fSneakerName)

	pPlasma.SetEmitFromObject(pEmitFrom)
	pPlasma.SetEmitPositionAndDirection(kEmitPos, kEmitDir)
	pPlasma.SetInheritsVelocity(0)
	
	pPlasma.AttachEffect(pAttachTo)

	App.TGProfilingInfo_StopTiming(iTimingId)

	return App.EffectAction_Create(pPlasma)
####################################################### End Sneaker98 plasma Changes

############################################################### Sneaker98 plasma changes
def	CreatePlasma(fSize, pEvent, pEffectRoot, kEmitPos, fSneakerName):
	
	# Set up the emit point.
	# Attach it to the hit point.
	pTargetObject = pEvent.GetTargetObject()
	kEmitDir = pEvent.GetObjectHitNormal()

	pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pTargetObject.GetNode())

	return CreatePlasmaHigh(0.001, App.g_kSystemWrapper.GetRandomNumber(25) + 60.0, fSize, pEmitFrom, kEmitPos, kEmitDir, pEffectRoot, fSneakerName)
############################################################### End Sneaker98 plasma changes
