import App

#effects for spatial charges

######################################################################### Sneaker98 Changes
def CreateExplosionSpatialHigh(fVelocity, fLife, fSize, pEmitFrom, kEmitPos, kEmitDir, pAttachTo):

	iTimingId  = App.TGProfilingInfo_StartTiming("Effects::CreateExplosionSpatialHigh")

	pExplosion = App.AnimTSParticleController_Create()

	pExplosion.AddColorKey(0.0, 1.0, 1.0, 1.0)

	pExplosion.AddAlphaKey(0.4, 1.0)
	pExplosion.AddAlphaKey(0.7, 0.5)
	pExplosion.AddAlphaKey(1.0, 0.0)

	pExplosion.AddSizeKey(0.0, 2.0 * fSize)
	pExplosion.AddSizeKey(0.2, 1.5 * fSize)
	pExplosion.AddSizeKey(0.6, 1.6 * fSize)
	pExplosion.AddSizeKey(0.9, 2.0 * fSize)

	pExplosion.SetEmitVelocity(fVelocity)
	pExplosion.SetAngleVariance(App.g_kSystemWrapper.GetRandomNumber(359))

	# set up the emitter values
	# TWEAK ME
	fFrequency = 1
	pExplosion.SetEmitLife(3)
	pExplosion.SetEmitFrequency(fFrequency)
	pExplosion.SetEffectLifeTime(fLife)

	pExplosion.SetDrawOldToNew(0)

	# Set up the geometry
	pExplosion.CreateTarget("data/Textures/Effects/SpatialExplosion.tga")

	pExplosion.SetEmitFromObject(pEmitFrom)
	pExplosion.SetEmitPositionAndDirection(kEmitPos, kEmitDir)
	pExplosion.SetInheritsVelocity(0)

	# Attach the actual geometry to the effects root.
	pExplosion.AttachEffect(pAttachTo)

	App.TGProfilingInfo_StopTiming(iTimingId)

	return App.EffectAction_Create(pExplosion)

################################################################################## End Sneaker98 Changes

############################################################### Sneaker98 changes
def	CreateSpatialExplosion(fSize, pEvent, pEffectRoot):
	
	# Set up the emit point.
	# Attach it to the hit point.
	pTargetObject = pEvent.GetTargetObject()
	kEmitPos = pEvent.GetObjectHitPoint()
	kEmitDir = pEvent.GetObjectHitNormal()

	pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pTargetObject.GetNode())

	return CreateExplosionSpatialHigh(0.001, 1.25, fSize, pEmitFrom, kEmitPos, kEmitDir, pEffectRoot)
############################################################### End Sneaker98 changes